diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/cobalt-queue-disc.h ns-3.31/src/traffic-control/model/cobalt-queue-disc.h
--- ns-3.30.1/src/traffic-control/model/cobalt-queue-disc.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/cobalt-queue-disc.h	2020-06-27 17:38:30.000000000 -0700
@@ -214,8 +214,6 @@
   // Common to CoDel and Blue
   // Maintained by Cobalt
   Stats m_stats;                          //!< Cobalt statistics
-  // Supplied by user
-  uint32_t m_minBytes;                    //!< Minimum bytes in queue to allow a packet drop
 
   // Codel parameters
   // Maintained by Cobalt
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/codel-queue-disc.cc ns-3.31/src/traffic-control/model/codel-queue-disc.cc
--- ns-3.30.1/src/traffic-control/model/codel-queue-disc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/codel-queue-disc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -73,6 +73,11 @@
     .SetParent<QueueDisc> ()
     .SetGroupName ("TrafficControl")
     .AddConstructor<CoDelQueueDisc> ()
+    .AddAttribute ("UseEcn",
+                   "True to use ECN (packets are marked instead of being dropped)",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&CoDelQueueDisc::m_useEcn),
+                   MakeBooleanChecker ())
     .AddAttribute ("MaxSize",
                    "The maximum number of packets/bytes accepted by this queue disc.",
                    QueueSizeValue (QueueSize (QueueSizeUnit::BYTES, 1500 * DEFAULT_CODEL_LIMIT)),
@@ -94,6 +99,11 @@
                    StringValue ("5ms"),
                    MakeTimeAccessor (&CoDelQueueDisc::m_target),
                    MakeTimeChecker ())
+    .AddAttribute ("CeThreshold",
+                   "The CoDel CE threshold for marking packets",
+                   TimeValue (Time::Max ()),
+                   MakeTimeAccessor (&CoDelQueueDisc::m_ceThreshold),
+                   MakeTimeChecker ())
     .AddTraceSource ("Count",
                      "CoDel count",
                      MakeTraceSourceAccessor (&CoDelQueueDisc::m_count),
@@ -122,11 +132,7 @@
     m_dropping (false),
     m_recInvSqrt (~0U >> REC_INV_SQRT_SHIFT),
     m_firstAboveTime (0),
-    m_dropNext (0),
-    m_state1 (0),
-    m_state2 (0),
-    m_state3 (0),
-    m_states (0)
+    m_dropNext (0)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -136,24 +142,24 @@
   NS_LOG_FUNCTION (this);
 }
 
-void
-CoDelQueueDisc::NewtonStep (void)
+uint16_t
+CoDelQueueDisc::NewtonStep (uint16_t recInvSqrt, uint32_t count)
 {
-  NS_LOG_FUNCTION (this);
-  uint32_t invsqrt = ((uint32_t) m_recInvSqrt) << REC_INV_SQRT_SHIFT;
+  NS_LOG_FUNCTION_NOARGS ();
+  uint32_t invsqrt = ((uint32_t) recInvSqrt) << REC_INV_SQRT_SHIFT;
   uint32_t invsqrt2 = ((uint64_t) invsqrt * invsqrt) >> 32;
-  uint64_t val = (3ll << 32) - ((uint64_t) m_count * invsqrt2);
+  uint64_t val = (3ll << 32) - ((uint64_t) count * invsqrt2);
 
   val >>= 2; /* avoid overflow */
   val = (val * invsqrt) >> (32 - 2 + 1);
-  m_recInvSqrt = static_cast<uint16_t>(val >> REC_INV_SQRT_SHIFT);
+  return static_cast<uint16_t>(val >> REC_INV_SQRT_SHIFT);
 }
 
 uint32_t
-CoDelQueueDisc::ControlLaw (uint32_t t)
+CoDelQueueDisc::ControlLaw (uint32_t t, uint32_t interval, uint32_t recInvSqrt)
 {
-  NS_LOG_FUNCTION (this);
-  return t + ReciprocalDivide (Time2CoDel (m_interval), m_recInvSqrt << REC_INV_SQRT_SHIFT);
+  NS_LOG_FUNCTION_NOARGS ();
+  return t + ReciprocalDivide (interval, recInvSqrt << REC_INV_SQRT_SHIFT);
 }
 
 bool
@@ -216,7 +222,6 @@
     {
       NS_LOG_LOGIC ("Sojourn time has been above target for at least q->interval; it's OK to (possibly) drop packet.");
       okToDrop = true;
-      ++m_state1;
     }
   return okToDrop;
 }
@@ -255,20 +260,27 @@
         }
       else if (CoDelTimeAfterEq (now, m_dropNext))
         {
-          m_state2++;
           while (m_dropping && CoDelTimeAfterEq (now, m_dropNext))
             {
+              ++m_count;
+              m_recInvSqrt = NewtonStep (m_recInvSqrt, m_count);
               // It's time for the next drop. Drop the current packet and
               // dequeue the next. The dequeue might take us out of dropping
               // state. If not, schedule the next drop.
               // A large amount of packets in queue might result in drop
               // rates so high that the next drop should happen now,
               // hence the while loop.
+              if (m_useEcn && Mark (item, TARGET_EXCEEDED_MARK))
+                {
+                  NS_LOG_LOGIC ("Sojourn time is still above target and it's time for next drop or mark; marking " << item);
+                  NS_LOG_LOGIC ("Running ControlLaw for input m_dropNext: " << (double)m_dropNext / 1000000);
+                  m_dropNext = ControlLaw (now, Time2CoDel (m_interval), m_recInvSqrt);
+                  NS_LOG_LOGIC ("Scheduled next drop at " << (double) m_dropNext / 1000000);
+                  goto end;
+                }
               NS_LOG_LOGIC ("Sojourn time is still above target and it's time for next drop; dropping " << item);
               DropAfterDequeue (item, TARGET_EXCEEDED_DROP);
 
-              ++m_count;
-              NewtonStep ();
               item = GetInternalQueue (0)->Dequeue ();
 
               if (item)
@@ -288,7 +300,7 @@
                 {
                   /* schedule the next drop */
                   NS_LOG_LOGIC ("Running ControlLaw for input m_dropNext: " << (double)m_dropNext / 1000000);
-                  m_dropNext = ControlLaw (m_dropNext);
+                  m_dropNext = ControlLaw (m_dropNext, Time2CoDel (m_interval), m_recInvSqrt);
                   NS_LOG_LOGIC ("Scheduled next drop at " << (double)m_dropNext / 1000000);
                 }
             }
@@ -301,22 +313,25 @@
       NS_LOG_LOGIC ("Not in dropping state; decide if we have to enter the state and drop the first packet");
       if (okToDrop)
         {
-          // Drop the first packet and enter dropping state unless the queue is empty
-          NS_LOG_LOGIC ("Sojourn time goes above target, dropping the first packet " << item << " and entering the dropping state");
-          DropAfterDequeue (item, TARGET_EXCEEDED_DROP);
-
-          item = GetInternalQueue (0)->Dequeue ();
-
-          if (item)
+          if (m_useEcn && Mark (item, TARGET_EXCEEDED_MARK))
             {
-              NS_LOG_LOGIC ("Popped " << item);
-              NS_LOG_LOGIC ("Number packets remaining " << GetInternalQueue (0)->GetNPackets ());
-              NS_LOG_LOGIC ("Number bytes remaining " << GetInternalQueue (0)->GetNBytes ());
+              NS_LOG_LOGIC ("Sojourn time goes above target, marking the first packet " << item << " and entering the dropping state");
+            }
+          else
+            {
+              // Drop the first packet and enter dropping state unless the queue is empty
+              NS_LOG_LOGIC ("Sojourn time goes above target, dropping the first packet " << item << " and entering the dropping state");
+              DropAfterDequeue (item, TARGET_EXCEEDED_DROP);
+              item = GetInternalQueue (0)->Dequeue ();
+              if (item)
+                {
+                  NS_LOG_LOGIC ("Popped " << item);
+                  NS_LOG_LOGIC ("Number packets remaining " << GetInternalQueue (0)->GetNPackets ());
+                  NS_LOG_LOGIC ("Number bytes remaining " << GetInternalQueue (0)->GetNBytes ());
+                }
+              OkToDrop (item, now);
             }
-
-          OkToDrop (item, now);
           m_dropping = true;
-          ++m_state3;
           /*
            * if min went above target close to when we last went below it
            * assume that the drop rate that controlled the queue on the
@@ -326,7 +341,7 @@
           if (delta > 1 && CoDelTimeBefore (now - m_dropNext, 16 * Time2CoDel (m_interval)))
             {
               m_count = delta;
-              NewtonStep ();
+              m_recInvSqrt = NewtonStep (m_recInvSqrt, m_count);
             }
           else
             {
@@ -335,11 +350,16 @@
             }
           m_lastCount = m_count;
           NS_LOG_LOGIC ("Running ControlLaw for input now: " << (double)now);
-          m_dropNext = ControlLaw (now);
+          m_dropNext = ControlLaw (now, Time2CoDel (m_interval), m_recInvSqrt);
           NS_LOG_LOGIC ("Scheduled next drop at " << (double)m_dropNext / 1000000 << " now " << (double)now / 1000000);
         }
     }
-  ++m_states;
+  end:
+  uint32_t ldelay = Time2CoDel (Simulator::Now () - item->GetTimeStamp ());
+  if (item && m_useEcn && CoDelTimeAfter (ldelay, Time2CoDel (m_ceThreshold)) && Mark (item, CE_THRESHOLD_EXCEEDED_MARK))
+    {
+      NS_LOG_LOGIC ("Marking due to CeThreshold " << m_ceThreshold.GetSeconds ());
+    }
   return item;
 }
 
@@ -364,25 +384,25 @@
 bool
 CoDelQueueDisc::CoDelTimeAfter (uint32_t a, uint32_t b)
 {
-  return  ((int)(a) - (int)(b) > 0);
+  return  ((int64_t)(a) - (int64_t)(b) > 0);
 }
 
 bool
 CoDelQueueDisc::CoDelTimeAfterEq (uint32_t a, uint32_t b)
 {
-  return ((int)(a) - (int)(b) >= 0);
+  return ((int64_t)(a) - (int64_t)(b) >= 0);
 }
 
 bool
 CoDelQueueDisc::CoDelTimeBefore (uint32_t a, uint32_t b)
 {
-  return  ((int)(a) - (int)(b) < 0);
+  return  ((int64_t)(a) - (int64_t)(b) < 0);
 }
 
 bool
 CoDelQueueDisc::CoDelTimeBeforeEq (uint32_t a, uint32_t b)
 {
-  return ((int)(a) - (int)(b) <= 0);
+  return ((int64_t)(a) - (int64_t)(b) <= 0);
 }
 
 uint32_t
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/codel-queue-disc.h ns-3.31/src/traffic-control/model/codel-queue-disc.h
--- ns-3.30.1/src/traffic-control/model/codel-queue-disc.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/codel-queue-disc.h	2020-06-27 17:38:30.000000000 -0700
@@ -101,6 +101,9 @@
   // Reasons for dropping packets
   static constexpr const char* TARGET_EXCEEDED_DROP = "Target exceeded drop";  //!< Sojourn time above target
   static constexpr const char* OVERLIMIT_DROP = "Overlimit drop";  //!< Overlimit dropped packet
+  // Reasons for marking packets
+  static constexpr const char* TARGET_EXCEEDED_MARK = "Target exceeded mark";  //!< Sojourn time above target
+  static constexpr const char* CE_THRESHOLD_EXCEEDED_MARK = "CE threshold exceeded mark";  //!< Sojourn time above CE threshold
 
 private:
   friend class::CoDelQueueDiscNewtonStepTest;  // Test code
@@ -130,8 +133,11 @@
    * \brief Calculate the reciprocal square root of m_count by using Newton's method
    *  http://en.wikipedia.org/wiki/Methods_of_computing_square_roots#Iterative_methods_for_reciprocal_square_roots
    * m_recInvSqrt (new) = (m_recInvSqrt (old) / 2) * (3 - m_count * m_recInvSqrt^2)
+   * \param recInvSqrt reciprocal value of sqrt (count)
+   * \param count count value
+   * \return The new recInvSqrt value
    */
-  void NewtonStep (void);
+  static uint16_t NewtonStep (uint16_t recInvSqrt, uint32_t count);
 
   /**
    * \brief Determine the time for next drop
@@ -139,10 +145,12 @@
    * Here, we use m_recInvSqrt calculated by Newton's method in NewtonStep() to avoid
    * both sqrt() and divide operations
    *
-   * \param t Current next drop time
-   * \returns The new next drop time:
+   * \param t Current next drop time (in units of CoDel time)
+   * \param interval interval (in units of CoDel time)
+   * \param recInvSqrt reciprocal value of sqrt (count)
+   * \return The new next drop time (in units of CoDel time)
    */
-  uint32_t ControlLaw (uint32_t t);
+  static uint32_t ControlLaw (uint32_t t, uint32_t interval, uint32_t recInvSqrt);
 
   /**
    * \brief Determine whether a packet is OK to be dropped. The packet
@@ -193,19 +201,17 @@
 
   virtual void InitializeParams (void);
 
+  bool m_useEcn;                          //!< True if ECN is used (packets are marked instead of being dropped)
   uint32_t m_minBytes;                    //!< Minimum bytes in queue to allow a packet drop
   Time m_interval;                        //!< 100 ms sliding minimum time window width
   Time m_target;                          //!< 5 ms target queue delay
+  Time m_ceThreshold;                     //!< Threshold above which to CE mark
   TracedValue<uint32_t> m_count;          //!< Number of packets dropped since entering drop state
   TracedValue<uint32_t> m_lastCount;      //!< Last number of packets dropped since entering drop state
   TracedValue<bool> m_dropping;           //!< True if in dropping state
   uint16_t m_recInvSqrt;                  //!< Reciprocal inverse square root
   uint32_t m_firstAboveTime;              //!< Time to declare sojourn time above target
   TracedValue<uint32_t> m_dropNext;       //!< Time to drop next packet
-  uint32_t m_state1;                      //!< Number of times packet sojourn goes above target for interval
-  uint32_t m_state2;                      //!< Number of times we perform next drop while in dropping state
-  uint32_t m_state3;                      //!< Number of times we enter drop state and drop the fist packet
-  uint32_t m_states;                      //!< Total number of times we are in state 1, state 2, or state 3
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/fq-codel-queue-disc.cc ns-3.31/src/traffic-control/model/fq-codel-queue-disc.cc
--- ns-3.30.1/src/traffic-control/model/fq-codel-queue-disc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/fq-codel-queue-disc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -44,7 +44,8 @@
 
 FqCoDelFlow::FqCoDelFlow ()
   : m_deficit (0),
-    m_status (INACTIVE)
+    m_status (INACTIVE),
+    m_index (0)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -89,6 +90,19 @@
   return m_status;
 }
 
+void
+FqCoDelFlow::SetIndex (uint32_t index)
+{
+  NS_LOG_FUNCTION (this);
+  m_index = index;
+}
+
+uint32_t
+FqCoDelFlow::GetIndex (void) const
+{
+  return m_index;
+}
+
 
 NS_OBJECT_ENSURE_REGISTERED (FqCoDelQueueDisc);
 
@@ -98,6 +112,11 @@
     .SetParent<QueueDisc> ()
     .SetGroupName ("TrafficControl")
     .AddConstructor<FqCoDelQueueDisc> ()
+    .AddAttribute ("UseEcn",
+                   "True to use ECN (packets are marked instead of being dropped)",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&FqCoDelQueueDisc::m_useEcn),
+                   MakeBooleanChecker ())
     .AddAttribute ("Interval",
                    "The CoDel algorithm interval for each FQCoDel queue",
                    StringValue ("100ms"),
@@ -129,6 +148,21 @@
                    UintegerValue (0),
                    MakeUintegerAccessor (&FqCoDelQueueDisc::m_perturbation),
                    MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("CeThreshold",
+                   "The FqCoDel CE threshold for marking packets",
+                   TimeValue (Time::Max ()),
+                   MakeTimeAccessor (&FqCoDelQueueDisc::m_ceThreshold),
+                   MakeTimeChecker ())
+    .AddAttribute ("EnableSetAssociativeHash",
+                   "Enable/Disable Set Associative Hash",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&FqCoDelQueueDisc::m_enableSetAssociativeHash),
+                   MakeBooleanChecker ())
+    .AddAttribute ("SetWays",
+                   "The size of a set of queues (used by set associative hash)",
+                   UintegerValue (8),
+                   MakeUintegerAccessor (&FqCoDelQueueDisc::m_setWays),
+                   MakeUintegerChecker<uint32_t> ())
   ;
   return tid;
 }
@@ -158,16 +192,45 @@
   return m_quantum;
 }
 
+uint32_t
+FqCoDelQueueDisc::SetAssociativeHash (uint32_t flowHash)
+{
+  NS_LOG_FUNCTION (this << flowHash);
+
+  uint32_t h = (flowHash % m_flows);
+  uint32_t innerHash = h % m_setWays;
+  uint32_t outerHash = h - innerHash;
+
+  for (uint32_t i = outerHash; i < outerHash + m_setWays; i++)
+    {
+      auto it = m_flowsIndices.find (i);
+
+      if (it == m_flowsIndices.end ()
+          || (m_tags.find (i) != m_tags.end () && m_tags[i] == flowHash)
+          || StaticCast<FqCoDelFlow> (GetQueueDiscClass (it->second))->GetStatus () == FqCoDelFlow::INACTIVE)
+        {
+          // this queue has not been created yet or is associated with this flow
+          // or is inactive, hence we can use it
+          m_tags[i] = flowHash;
+          return i;
+        }
+    }
+
+  // all the queues of the set are used. Use the first queue of the set
+  m_tags[outerHash] = flowHash;
+  return outerHash;
+}
+
 bool
 FqCoDelQueueDisc::DoEnqueue (Ptr<QueueDiscItem> item)
 {
   NS_LOG_FUNCTION (this << item);
 
-  uint32_t h = 0;
+  uint32_t flowHash, h;
 
   if (GetNPacketFilters () == 0)
     {
-      h = item->Hash (m_perturbation) % m_flows;
+      flowHash = item->Hash (m_perturbation);
     }
   else
     {
@@ -175,7 +238,7 @@
 
       if (ret != PacketFilter::PF_NO_MATCH)
         {
-          h = ret % m_flows;
+          flowHash = static_cast<uint32_t> (ret);
         }
       else
         {
@@ -185,14 +248,31 @@
         }
     }
 
+  if (m_enableSetAssociativeHash)
+    {
+      h = SetAssociativeHash (flowHash);
+    }
+  else
+    {
+      h = flowHash % m_flows;
+    }
+
   Ptr<FqCoDelFlow> flow;
   if (m_flowsIndices.find (h) == m_flowsIndices.end ())
     {
       NS_LOG_DEBUG ("Creating a new flow queue with index " << h);
       flow = m_flowFactory.Create<FqCoDelFlow> ();
       Ptr<QueueDisc> qd = m_queueDiscFactory.Create<QueueDisc> ();
+      // If CoDel, Set values of CoDelQueueDisc to match this QueueDisc
+      Ptr<CoDelQueueDisc> codel = qd->GetObject<CoDelQueueDisc> ();
+      if (codel)
+        {
+          codel->SetAttribute ("UseEcn", BooleanValue (m_useEcn));
+          codel->SetAttribute ("CeThreshold", TimeValue (m_ceThreshold));
+        }
       qd->Initialize ();
       flow->SetQueueDisc (qd);
+      flow->SetIndex (h);
       AddQueueDiscClass (flow);
 
       m_flowsIndices[h] = GetNQueueDiscClasses () - 1;
@@ -215,6 +295,7 @@
 
   if (GetCurrentSize () > GetMaxSize ())
     {
+      NS_LOG_DEBUG ("Overload; enter FqCodelDrop ()");
       FqCoDelDrop ();
     }
 
@@ -239,6 +320,7 @@
 
           if (flow->GetDeficit () <= 0)
             {
+              NS_LOG_DEBUG ("Increase deficit for new flow index " << flow->GetIndex ());
               flow->IncreaseDeficit (m_quantum);
               flow->SetStatus (FqCoDelFlow::OLD_FLOW);
               m_oldFlows.push_back (flow);
@@ -246,7 +328,7 @@
             }
           else
             {
-              NS_LOG_DEBUG ("Found a new flow with positive deficit");
+              NS_LOG_DEBUG ("Found a new flow " << flow->GetIndex () << " with positive deficit");
               found = true;
             }
         }
@@ -257,13 +339,14 @@
 
           if (flow->GetDeficit () <= 0)
             {
+              NS_LOG_DEBUG ("Increase deficit for old flow index " << flow->GetIndex ());
               flow->IncreaseDeficit (m_quantum);
               m_oldFlows.push_back (flow);
               m_oldFlows.pop_front ();
             }
           else
             {
-              NS_LOG_DEBUG ("Found an old flow with positive deficit");
+              NS_LOG_DEBUG ("Found an old flow " << flow->GetIndex () << " with positive deficit");
               found = true;
             }
         }
@@ -339,6 +422,13 @@
         }
     }
 
+  if (m_enableSetAssociativeHash && (m_flows % m_setWays != 0))
+    {
+      NS_LOG_ERROR ("The number of queues must be an integer multiple of the size "
+                    "of the set of queues used by set associative hash");
+      return false;
+    }
+
   return true;
 }
 
@@ -382,6 +472,7 @@
 
   do
     {
+      NS_LOG_DEBUG ("Drop packet (overflow); count: " << count << " len: " << len << " threshold: " << threshold);
       item = qd->GetInternalQueue (0)->Dequeue ();
       DropAfterDequeue (item, OVERLIMIT_DROP);
       len += item->GetSize ();
@@ -391,3 +482,4 @@
 }
 
 } // namespace ns3
+
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/fq-codel-queue-disc.h ns-3.31/src/traffic-control/model/fq-codel-queue-disc.h
--- ns-3.30.1/src/traffic-control/model/fq-codel-queue-disc.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/fq-codel-queue-disc.h	2020-06-27 17:38:30.000000000 -0700
@@ -85,10 +85,21 @@
    * \return the status of this flow
    */
   FlowStatus GetStatus (void) const;
+  /**
+   * \brief Set the index for this flow
+   * \param index the index for this flow
+   */
+  void SetIndex (uint32_t index);
+  /**
+   * \brief Get the index of this flow
+   * \return the index of this flow
+   */
+  uint32_t GetIndex (void) const;
 
 private:
   int32_t m_deficit;    //!< the deficit for this flow
   FlowStatus m_status;  //!< the status of this flow
+  uint32_t m_index;     //!< the index for this flow
 };
 
 
@@ -142,17 +153,31 @@
    */
   uint32_t FqCoDelDrop (void);
 
+  bool m_useEcn;             //!< True if ECN is used (packets are marked instead of being dropped)
+  /**
+   * Compute the index of the queue for the flow having the given flowHash,
+   * according to the set associative hash approach.
+   *
+   * \param flowHash the hash of the flow 5-tuple
+   * \return the index of the queue for the given flow
+   */
+  uint32_t SetAssociativeHash (uint32_t flowHash);
+
   std::string m_interval;    //!< CoDel interval attribute
   std::string m_target;      //!< CoDel target attribute
   uint32_t m_quantum;        //!< Deficit assigned to flows at each round
   uint32_t m_flows;          //!< Number of flow queues
+  uint32_t m_setWays;        //!< size of a set of queues (used by set associative hash)
   uint32_t m_dropBatchSize;  //!< Max number of packets dropped from the fat flow
   uint32_t m_perturbation;   //!< hash perturbation value
+  Time m_ceThreshold;        //!< Threshold above which to CE mark
+  bool m_enableSetAssociativeHash; //!< whether to enable set associative hash
 
   std::list<Ptr<FqCoDelFlow> > m_newFlows;    //!< The list of new flows
   std::list<Ptr<FqCoDelFlow> > m_oldFlows;    //!< The list of old flows
 
   std::map<uint32_t, uint32_t> m_flowsIndices;    //!< Map with the index of class for each flow
+  std::map<uint32_t, uint32_t> m_tags;            //!< Tags used by set associative hash
 
   ObjectFactory m_flowFactory;         //!< Factory to create a new flow
   ObjectFactory m_queueDiscFactory;    //!< Factory to create a new queue
@@ -161,3 +186,4 @@
 } // namespace ns3
 
 #endif /* FQ_CODEL_QUEUE_DISC */
+
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/pie-queue-disc.cc ns-3.31/src/traffic-control/model/pie-queue-disc.cc
--- ns-3.30.1/src/traffic-control/model/pie-queue-disc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/pie-queue-disc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -115,7 +115,7 @@
 {
   NS_LOG_FUNCTION (this);
   m_uv = 0;
-  Simulator::Remove (m_rtrsEvent);
+  m_rtrsEvent.Cancel ();
   QueueDisc::DoDispose ();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/queue-disc.cc ns-3.31/src/traffic-control/model/queue-disc.cc
--- ns-3.30.1/src/traffic-control/model/queue-disc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/queue-disc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -360,6 +360,11 @@
       return DropAfterDequeue (item,
                                m_childQueueDiscDropMsg.assign (CHILD_QUEUE_DISC_DROP).append (r).data ());
     };
+  m_childQueueDiscMarkFunctor = [this] (Ptr<const QueueDiscItem> item, const char* r)
+    {
+      return Mark (const_cast<QueueDiscItem *> (PeekPointer (item)),
+                   m_childQueueDiscMarkMsg.assign (CHILD_QUEUE_DISC_MARK).append (r).data ());
+    };
 }
 
 QueueDisc::QueueDisc (QueueDiscSizePolicy policy, QueueSizeUnit unit)
@@ -636,7 +641,7 @@
                    "A queue disc with WAKE_CHILD as wake mode can only be a root queue disc");
 
   // set the parent callbacks on the child queue disc, so that it can notify
-  // the parent queue disc of packets enqueued, dequeued or dropped
+  // the parent queue disc of packets enqueued, dequeued, dropped, or marked
   qdClass->GetQueueDisc ()->TraceConnectWithoutContext ("Enqueue",
                                      MakeCallback (&QueueDisc::PacketEnqueued, this));
   qdClass->GetQueueDisc ()->TraceConnectWithoutContext ("Dequeue",
@@ -647,6 +652,9 @@
   qdClass->GetQueueDisc ()->TraceConnectWithoutContext ("DropAfterDequeue",
                                      MakeCallback (&ChildQueueDiscDropFunctor::operator(),
                                                    &m_childQueueDiscDadFunctor));
+  qdClass->GetQueueDisc ()->TraceConnectWithoutContext ("Mark",
+                                     MakeCallback (&ChildQueueDiscMarkFunctor::operator(),
+                                                   &m_childQueueDiscMarkFunctor));
   m_classes.push_back (qdClass);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/queue-disc.h ns-3.31/src/traffic-control/model/queue-disc.h
--- ns-3.30.1/src/traffic-control/model/queue-disc.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/queue-disc.h	2020-06-27 17:38:30.000000000 -0700
@@ -515,6 +515,7 @@
   // Reasons for dropping packets
   static constexpr const char* INTERNAL_QUEUE_DROP = "Dropped by internal queue";    //!< Packet dropped by an internal queue
   static constexpr const char* CHILD_QUEUE_DISC_DROP = "(Dropped by child queue disc) "; //!< Packet dropped by a child queue disc
+  static constexpr const char* CHILD_QUEUE_DISC_MARK = "(Marked by child queue disc) "; //!< Packet marked by a child queue disc
 
 protected:
   /**
@@ -528,6 +529,8 @@
    * This method is not virtual to prevent subclasses from redefining it.
    * Subclasses must instead provide the implementation of the CheckConfig
    * and InitializeParams methods (which are called by this method).
+   * \sa QueueDisc::InitializeParams
+   * \sa QueueDisc::CheckConfig
    */
   void DoInitialize (void);
 
@@ -615,13 +618,21 @@
   /**
    * Check whether the current configuration is correct. Default objects (such
    * as internal queues) might be created by this method to ensure the
-   * configuration is correct.
+   * configuration is correct.  This method is automatically called at
+   * simulation initialization time, and it is called before
+   * the InitializeParams () method.  It is appropriate to promote parameter
+   * initialization to this method if it aids in checking for correct
+   * configuration.
+   * \sa QueueDisc::InitializeParams
    * \return true if the configuration is correct, false otherwise
    */
   virtual bool CheckConfig (void) = 0;
 
   /**
    * Initialize parameters (if any) before the first packet is enqueued.
+   * This method is automatically called at simulation initialization time,
+   * after the CheckConfig() method has been called.
+   * \sa QueueDisc::CheckConfig
    */
   virtual void InitializeParams (void) = 0;
 
@@ -699,6 +710,7 @@
   Ptr<QueueDiscItem> m_requeued;    //!< The last packet that failed to be transmitted
   bool m_peeked;                    //!< A packet was dequeued because Peek was called
   std::string m_childQueueDiscDropMsg;  //!< Reason why a packet was dropped by a child queue disc
+  std::string m_childQueueDiscMarkMsg;  //!< Reason why a packet was marked by a child queue disc
   QueueDiscSizePolicy m_sizePolicy;     //!< The queue disc size policy
   bool m_prohibitChangeMode;            //!< True if changing mode is prohibited
 
@@ -721,6 +733,8 @@
   typedef std::function<void (Ptr<const QueueDiscItem>)> InternalQueueDropFunctor;
   /// Type for the function objects notifying that a packet has been dropped by a child queue disc
   typedef std::function<void (Ptr<const QueueDiscItem>, const char*)> ChildQueueDiscDropFunctor;
+  /// Type for the function objects notifying that a packet has been marked by a child queue disc
+  typedef std::function<void (Ptr<const QueueDiscItem>, const char*)> ChildQueueDiscMarkFunctor;
 
   /// Function object called when an internal queue dropped a packet before enqueue
   InternalQueueDropFunctor m_internalQueueDbeFunctor;
@@ -730,6 +744,8 @@
   ChildQueueDiscDropFunctor m_childQueueDiscDbeFunctor;
   /// Function object called when a child queue disc dropped a packet after dequeue
   ChildQueueDiscDropFunctor m_childQueueDiscDadFunctor;
+  /// Function object called when a child queue disc marked a packet
+  ChildQueueDiscMarkFunctor m_childQueueDiscMarkFunctor;
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/tbf-queue-disc.cc ns-3.31/src/traffic-control/model/tbf-queue-disc.cc
--- ns-3.30.1/src/traffic-control/model/tbf-queue-disc.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/tbf-queue-disc.cc	2020-06-27 17:38:30.000000000 -0700
@@ -310,6 +310,9 @@
       return false;
     }
 
+  // This type of variable initialization would normally be done in
+  // InitializeParams (), but we want to use the value to subsequently
+  // check configuration of peak rate, so we move it forward here.
   if (m_mtu == 0)
     {
       Ptr<NetDeviceQueueInterface> ndqi = GetNetDeviceQueueInterface ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/traffic-control/model/traffic-control-layer.cc ns-3.31/src/traffic-control/model/traffic-control-layer.cc
--- ns-3.30.1/src/traffic-control/model/traffic-control-layer.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/traffic-control/model/traffic-control-layer.cc	2020-06-27 17:38:30.000000000 -0700
@@ -57,7 +57,7 @@
 TrafficControlLayer::TrafficControlLayer ()
   : Object ()
 {
-  NS_LOG_FUNCTION_NOARGS ();
+  NS_LOG_FUNCTION (this);
 }
 
 TrafficControlLayer::~TrafficControlLayer ()
@@ -119,17 +119,22 @@
 
   NS_ASSERT_MSG (m_node, "Cannot run ScanDevices without an aggregated node");
 
+  NS_LOG_DEBUG ("Scanning devices on node " << m_node->GetId ());
   for (uint32_t i = 0; i < m_node->GetNDevices (); i++)
     {
+      NS_LOG_DEBUG ("Scanning devices on node " << m_node->GetId ());
       Ptr<NetDevice> dev = m_node->GetDevice (i);
+      NS_LOG_DEBUG ("Checking device " << i << " with pointer " << dev << " of type " << dev->GetInstanceTypeId ().GetName ());
 
       // note: there may be no NetDeviceQueueInterface aggregated to the device
       Ptr<NetDeviceQueueInterface> ndqi = dev->GetObject<NetDeviceQueueInterface> ();
+      NS_LOG_DEBUG ("Pointer to NetDeviceQueueInterface: " << ndqi);
 
       std::map<Ptr<NetDevice>, NetDeviceInfo>::iterator ndi = m_netDevices.find (dev);
 
       if (ndi != m_netDevices.end ())
         {
+          NS_LOG_DEBUG ("Device entry found; installing NetDeviceQueueInterface pointer " << ndqi << " to internal map");
           ndi->second.m_ndqi = ndqi;
         }
       else if (ndqi)
@@ -139,6 +144,7 @@
       // the Traffic Control layer checks whether the device queue is stopped even
       // when there is no queue disc.
         {
+          NS_LOG_DEBUG ("No device entry found; create entry for device and store pointer to NetDeviceQueueInterface: " << ndqi);
           m_netDevices[dev] = {nullptr, ndqi, QueueDiscVector ()};
           ndi = m_netDevices.find (dev);
         }
@@ -146,6 +152,7 @@
       // if a queue disc is installed, set the wake callbacks on netdevice queues
       if (ndi != m_netDevices.end () && ndi->second.m_rootQueueDisc)
         {
+          NS_LOG_DEBUG ("Setting the wake callbacks on NetDevice queues");
           ndi->second.m_queueDiscsToWake.clear ();
 
           if (ndqi)
